## fortran-testdrive 0.5.0

=== CMakeLists.txt ===
# This file is part of test-drive.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.9)
get_directory_property(is-subproject PARENT_DIRECTORY)

project(
  "test-drive"
  LANGUAGES "Fortran"
  VERSION "0.5.0"
  DESCRIPTION "The simple testing framework"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

# General configuration information
add_subdirectory("config")

# Collect source of the project
set(srcs)
add_subdirectory("src")

# We need the module directory before we finish the configure stage
if(NOT EXISTS "${PROJECT_BINARY_DIR}/include")
  make_directory("${PROJECT_BINARY_DIR}/include")
endif()

# Testing library target
add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)
set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${PROJECT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${PROJECT_BINARY_DIR}/include"
)
target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)
target_compile_definitions(
  "${PROJECT_NAME}-lib"
  PRIVATE
  "WITH_QP=$<BOOL:${WITH_QP}>"
  "WITH_XDP=$<BOOL:${WITH_XDP}>"
)

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${PROJECT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "LICENSE-Apache"
  "LICENSE-MIT"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

# add the testsuite
include(CTest)
if(BUILD_TESTING AND TEST_DRIVE_BUILD_TESTING)
  add_subdirectory("test")
endif()

=== meson_options.txt ===
# This file is part of test-drive.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option(
  'openmp',
  type: 'boolean',
  value: false,
  yield: true,
  description: 'use OpenMP parallelisation',
)

option(
  'xdp',
  type: 'feature',
  value: 'auto',
  description: 'Support extended double precision',
)

option(
  'qp',
  type: 'feature',
  value: 'auto',
  description: 'Support quadruple precision',
)

=== requirements.txt ===
meson
ninja
gcovr

=== config/CMakeLists.txt ===
# This file is part of test-drive.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)
option(TEST_DRIVE_BUILD_TESTING "Enable testing for this project" ON)

set(
  module-dir
  "${PROJECT_NAME}/${CMAKE_Fortran_COMPILER_ID}-${CMAKE_Fortran_COMPILER_VERSION}"
)
set(module-dir "${module-dir}" PARENT_SCOPE)

# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

include(CheckFortranSourceCompiles)
if(NOT DEFINED WITH_QP)
  check_fortran_source_compiles(
    "integer, parameter :: qp = selected_real_kind(33); complex(qp) :: x; end"
    WITH_QP
  )
  set(WITH_QP ${WITH_QP} PARENT_SCOPE)
endif()
if(NOT DEFINED WITH_XDP)
  check_fortran_source_compiles(
    "
    integer, parameter :: xdp = merge(-1, selected_real_kind(18), selected_real_kind(18) == selected_real_kind(33))
    complex(xdp) :: x
    end
    "
    WITH_XDP
  )
  set(WITH_XDP ${WITH_XDP} PARENT_SCOPE)
endif()

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY SameMinorVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.pc"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== src/CMakeLists.txt ===
# This file is part of test-drive.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/testdrive.F90"
  "${dir}/testdrive_version.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== test/CMakeLists.txt ===
# This file is part of test-drive.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Unit testing
set(
  tests
  "check"
  "select"
)
set(
  test-srcs
  "main.f90"
)
foreach(t IN LISTS tests)
  string(MAKE_C_IDENTIFIER ${t} t) 
  list(APPEND test-srcs "test_${t}.F90")
endforeach()

add_executable(
  "${PROJECT_NAME}-tester"
  "${test-srcs}"
)
target_link_libraries(
  "${PROJECT_NAME}-tester"
  PRIVATE
  "${PROJECT_NAME}-lib"
)
target_compile_definitions(
  "${PROJECT_NAME}-tester"
  PRIVATE
  "WITH_QP=$<BOOL:${WITH_QP}>"
  "WITH_XDP=$<BOOL:${WITH_XDP}>"
)

add_test("${PROJECT_NAME}/all-tests" "${PROJECT_NAME}-tester")

foreach(t IN LISTS tests)
  add_test("${PROJECT_NAME}/${t}" "${PROJECT_NAME}-tester" "${t}")
endforeach()

=== debian/changelog ===
fortran-testdrive (0.5.0-7) unstable; urgency=medium

  * Fix pkgconfig file: ship "CFlags" pointing to fmoddir and subdir

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Jan 2026 08:09:33 +0000

fortran-testdrive (0.5.0-6) unstable; urgency=medium

  * Move dh-fortran-mod -> dh-fortran
  * d/watch: Move to version 5 syntax
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Add Section: needed for dh-fortran autodetection
  * Fix pkg-config creation. Needs dh-fortran >= 0.61

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Jan 2026 18:09:19 +0000

fortran-testdrive (0.5.0-5) unstable; urgency=medium

  * Add libdir/fortran/gnu to path in pkgconfig file

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 24 Oct 2025 09:34:51 +0100

fortran-testdrive (0.5.0-4) unstable; urgency=medium

  * Now use --with fortran
  * Use libfortran-testdrive-dev.fortran_lib file rather than directly
  * Build-dep on gfortran

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 19 Oct 2025 11:24:44 +0100

fortran-testdrive (0.5.0-3) unstable; urgency=medium

  * Fix search paths in test-drive.pc file

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 17 Sep 2025 13:52:32 +0100

fortran-testdrive (0.5.0-2) unstable; urgency=medium

  * Add debian/watch file

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Sep 2025 13:34:50 +0100

fortran-testdrive (0.5.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1111580)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 19 Aug 2025 19:46:28 +0100

=== debian/control ===
Source: fortran-testdrive
Section: utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Standards-Version: 4.7.3
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-fortran (>= 0.61),
 gfortran,
 meson
Homepage: https://github.com/fortran-lang/test-drive
Vcs-Browser: https://salsa.debian.org/science-team/fortran-testdrive
Vcs-Git: https://salsa.debian.org/science-team/fortran-testdrive.git -b debian/latest

Package: libfortran-testdrive-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},${fortran:Depends},
 libfortran-testdrive-0 ( = ${binary:Version})
Recommends: pkgconf
Description: Simple Fortran testing framework - devel files
 This project offers a lightweight, procedural unit testing framework
 based on nothing but standard Fortran. Integration with meson,
 cmake and Fortran package manager (fpm) is available.

Package: libfortran-testdrive-0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Simple Fortran testing framework - library
 This project offers a lightweight, procedural unit testing framework
 based on nothing but standard Fortran. Integration with meson,
 cmake and Fortran package manager (fpm) is available.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
include /usr/share/dpkg/architecture.mk

FMODDIR:=$(shell dh_fortran get_fmoddir)
FLIBDIR:=$(shell dh_fortran get_flibdir)

PKGFILE=debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/test-drive.pc

# The magic debhelper  rule
%:
	dh $@ --with fortran


override_dh_auto_clean:
	rm -rf build 

override_dh_auto_configure:
	meson setup build --prefix=$(CURDIR)/debian/tmp/usr

override_dh_auto_build:
	meson compile -C build	

override_dh_auto_test:
	@echo Bypass tests this build. require downloads

override_dh_auto_install:
	meson install -C build
	sed -i -e 's%@FMODDIR@%${FMODDIR}%' $(PKGFILE)
	sed -i -e 's%@FLIBDIR@%${FLIBDIR}%' $(PKGFILE)
	sed -i -e 's%{libdir}%{flibdir}%' $(PKGFILE)
	sed -i -e 's%{includedir}%{fmoddir}%g' $(PKGFILE)

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/fortran-lang/test-drive
